import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";

var _dec, _class, _class2, _temp;

import React from 'react';
import PropTypes from 'prop-types';
import { moduleContext } from 'react-contextual';
import CanvasImpl from 'awv3/core/canvas';
var Canvas = (_dec = moduleContext(), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Canvas, _React$PureComponent);

  function Canvas(props) {
    var _this;

    _this = _React$PureComponent.call(this) || this;

    _this.onContextMenu = function (event) {
      return event.preventDefault();
    };

    _this.catchRef = function (ref) {
      return _this.ref = ref;
    };

    var options = {};
    if (props.resolution) options.resolution = props.resolution;
    _this.interface = new CanvasImpl(options);
    return _this;
  }

  var _proto = Canvas.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    this.interface.dom.style.position = 'absolute';
    this.ref.insertBefore(this.interface.dom, this.ref.firstChild);
    setTimeout(function () {
      return _this2.interface.renderer && _this2.interface.renderer.resize();
    }, 200);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    if (this.interface) {
      this.interface.destroy();
    }
  };

  _proto.render = function render() {
    var _this$props = this.props,
        resolution = _this$props.resolution,
        children = _this$props.children,
        style = _this$props.style,
        Context = _this$props.context,
        props = _objectWithoutPropertiesLoose(_this$props, ["resolution", "children", "style", "context"]);

    return React.createElement(Context.Provider, {
      value: this.interface
    }, React.createElement("div", _extends({
      onContextMenu: this.onContextMenu,
      ref: this.catchRef
    }, props, {
      style: _extends({
        height: '100%',
        width: '100%',
        overflow: 'hidden'
      }, style)
    }), children));
  };

  return Canvas;
}(React.PureComponent), _class2.propTypes = {
  resolution: PropTypes.number
}, _temp)) || _class);
export { Canvas as default };