import _extends from "@babel/runtime/helpers/extends";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";

var _dec, _class, _class2, _temp;

import React from 'react';
import { subscribe, Subscribe } from 'react-contextual';
import PropTypes from 'prop-types';
import Presentation from 'awv3/misc/presentation';
import SessionProvider from './SessionProvider';
import Canvas from './Canvas';
import View from './View';
import ViewCube from './ViewCube';
var Csys = (_dec = subscribe([SessionProvider, View], function (session, viewSession) {
  return {
    session: session,
    viewSession: viewSession
  };
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Csys, _React$PureComponent);

  function Csys() {
    return _React$PureComponent.apply(this, arguments) || this;
  }

  var _proto = Csys.prototype;

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.unsub && this.unsub();
  };

  _proto.render = function render() {
    var _this = this;

    return React.createElement(Canvas, {
      style: this.props.style,
      resolution: 2,
      className: "csys"
    }, React.createElement(View, {
      up: this.props.viewSession.camera.up.toArray()
    }, React.createElement(Subscribe, {
      to: View,
      select: function select(viewCsys) {
        return {
          viewCsys: viewCsys
        };
      }
    }, function (_ref) {
      var viewCsys = _ref.viewCsys;
      return ViewCube.init(_extends({}, _this.props, {
        viewCsys: viewCsys
      })) || null;
    })));
  };

  return Csys;
}(React.PureComponent), _class2.propTypes = {
  textures: PropTypes.array,
  radius: PropTypes.number,
  chamfer: PropTypes.number,
  opacity: PropTypes.number,
  showAxes: PropTypes.bool,
  showFaceNames: PropTypes.bool
}, _class2.defaultProps = {
  radius: 14,
  chamfer: 0.35,
  opacity: 1,
  showAxes: false,
  showFaceNames: false
}, _temp)) || _class);
export { Csys as default };