import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";

var _dec, _class, _class2, _temp;

import * as THREE from 'three';
import React from 'react';
import PropTypes from 'prop-types';
import { subscribe } from 'react-contextual';
import Selector from 'awv3/session/selector';
import SessionProvider from './SessionProvider';
var HOVERED = THREE.Object3D.Events.Interaction.Hovered;
var UNHOVERED = THREE.Object3D.Events.Interaction.Unhovered;
var Selection = (_dec = subscribe(SessionProvider, function (session) {
  return {
    session: session
  };
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Selection, _React$PureComponent);

  function Selection() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args)) || this;
    _this.state = {
      materials: [],
      ids: [],
      hovered: undefined
    };
    return _this;
  }

  var _proto = Selection.prototype;

  _proto.componentDidMount = function componentDidMount() {
    if (this.props.enabled) this.createSelector();
  };

  _proto.componentWillReceiveProps = function componentWillReceiveProps(next) {
    if (this.sel && !next.enabled) this.destroySelector();else if (!this.sel && next.enabled) this.createSelector();
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.destroySelector();
  };

  _proto.render = function render() {
    return this.props.children(this.state) || null;
  };

  _proto.createSelector = function createSelector() {
    var _this2 = this,
        _on;

    this.sel = new Selector(this.props.session, {
      ids: this.state.ids,
      types: this.props.types,
      limit: this.props.limit
    }).on((_on = {
      changed: function changed() {
        return _this2.setState({
          materials: _this2.sel.selectedMaterials,
          ids: _this2.sel.selectedIds
        });
      }
    }, _on[HOVERED] = function (props) {
      return _this2.setState({
        hovered: props
      });
    }, _on[UNHOVERED] = function (props) {
      return _this2.setState({
        hovered: undefined
      });
    }, _on));
  };

  _proto.destroySelector = function destroySelector() {
    this.sel.destroy();
    this.sel = undefined;
  };

  return Selection;
}(React.PureComponent), _class2.propTypes = {
  enabled: PropTypes.bool,
  types: PropTypes.array,
  limit: PropTypes.number,
  children: PropTypes.func.isRequired
}, _class2.defaultProps = {
  enabled: true,
  types: ['Mesh'],
  limit: Infinity
}, _temp)) || _class);
export { Selection as default };