import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";

var _dec, _dec2, _class, _class2, _temp;

import * as THREE from 'three';
import React from 'react';
import { Provider } from 'react-redux';
import { moduleContext, subscribe } from 'react-contextual';
import PropTypes from 'prop-types';
import Defaults from 'awv3/core/defaults';
import pool from 'awv3/misc/presentation';
import protocol from 'awv3/communication/socketio';
import SessionImpl from 'awv3/session';
import { actions as connectionActions } from 'awv3/session/store/connections';
import Canvas from './Canvas';
import View from './View';
import Csys from './Csys';
import SessionProvider from './SessionProvider';
var styles = {
  canvas: {
    position: 'absolute',
    ransition: 'background-color 0.5s',
    top: 0,
    left: 0
  },
  csys: {
    position: 'absolute',
    bottom: 2,
    left: 2,
    width: 80,
    height: 80
  }
};
var Session = (_dec = moduleContext(), _dec2 = subscribe(SessionProvider, function (session) {
  return {
    session: session
  };
}), _dec(_class = _dec2(_class = (_temp = _class2 =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Session, _React$PureComponent);

  function Session(props) {
    var _this;

    _this = _React$PureComponent.call(this) || this;
    _this.state = {
      onDrop: false
    };

    _this.openFile = function (event) {
      return _this.open(event.target.files);
    };

    _this.onDrop = function (event) {
      return event.preventDefault() || _this.setState({
        onDrop: false
      }, _this.props.onDragLeave) || _this.open(event.dataTransfer.files);
    };

    _this.onDragEnter = function (event) {
      return event.preventDefault() || _this.setState({
        onDrop: true
      }, _this.props.onDragEnter);
    };

    _this.onDragLeave = function (event) {
      return event.preventDefault() || _this.setState({
        onDrop: false
      }, _this.props.onDragLeave);
    };

    _this.onDragOver = function (event) {
      return event.preventDefault();
    };

    _this.onDoubleClick = function (event) {
      if (_this.props.session.pool.view) _this.props.session.pool.view.updateBounds().controls.focus().zoom();
    };

    return _this;
  }

  var _proto = Session.prototype;

  _proto.open = function open(files) {
    var _this$props = this.props,
        session = _this$props.session,
        onInitConnection = _this$props.onInitConnection,
        onOpen = _this$props.onOpen;
    this.setState({
      onDrop: false
    });
    return session.open(files, onInitConnection, onOpen);
  };

  _proto.render = function render() {
    var onDrop = this.state.onDrop;

    var _this$props2 = this.props,
        style = _this$props2.style,
        canvasStyle = _this$props2.canvasStyle,
        className = _this$props2.className,
        resolution = _this$props2.resolution,
        up = _this$props2.up,
        stats = _this$props2.stats,
        csys = _this$props2.csys,
        children = _this$props2.children,
        context = _this$props2.context,
        drop = _this$props2.drop,
        rest = _objectWithoutPropertiesLoose(_this$props2, ["style", "canvasStyle", "className", "resolution", "up", "stats", "csys", "children", "context", "drop"]);

    return React.createElement("div", {
      className: className,
      style: style
    }, React.createElement(Canvas, {
      style: _extends({}, styles.canvas, {
        backgroundColor: 'transparent'
      }, canvasStyle),
      resolution: resolution,
      onDoubleClick: this.onDoubleClick,
      onDragOver: drop ? this.onDragOver : null,
      onDragEnter: drop ? this.onDragEnter : null,
      onDragLeave: drop ? this.onDragLeave : null,
      onDrop: drop ? this.onDrop : null
    }, React.createElement(View, {
      up: up,
      stats: stats,
      pool: this.props.session.pool
    }, csys && csys.visible !== false && React.createElement(Csys, _extends({
      style: csys.style
    }, csys, {
      startUp: up
    })))), children && React.createElement(context.Provider, {
      value: this,
      children: children
    }));
  };

  return Session;
}(React.PureComponent), _class2.propTypes = {
  drop: PropTypes.bool,
  onOpen: PropTypes.func,
  onInitConnection: PropTypes.func,
  csys: PropTypes.object
}, _class2.defaultProps = {
  interpolatePoints: false,
  drop: false
}, _temp)) || _class) || _class);
export { Session as default };