import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";

var _dec, _class, _class2, _temp;

import * as THREE from 'three';
import React from 'react';
import ReactDOM from 'react-dom';
import { moduleContext } from 'react-contextual';
import PropTypes from 'prop-types';
import { Provider } from 'react-redux';
import Defaults from 'awv3/core/defaults';
import SessionImpl from 'awv3/session';
import CubeTexture from 'awv3/three/cubetexture';
import protocol from 'awv3/communication/socketio';
import pool from 'awv3/misc/presentation';
var SessionProvider = (_dec = moduleContext(), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(SessionProvider, _React$PureComponent);

  function SessionProvider(props) {
    var _this;

    _this = _React$PureComponent.call(this) || this;
    _this.state = {
      onDrop: false
    };
    _this.interface = window.session = props.session || new SessionImpl(props);
    return _this;
  }

  var _proto = SessionProvider.prototype;

  _proto.componentWillUnmount = function componentWillUnmount() {// Destroy session?
  };

  _proto.render = function render() {
    var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style,
        children = _this$props.children,
        Context = _this$props.context;
    return React.createElement(Provider, {
      store: this.interface.store
    }, React.createElement(Context.Provider, {
      value: this.interface
    }, children));
  };

  return SessionProvider;
}(React.PureComponent), _class2.propTypes = {
  debug: PropTypes.bool,
  pool: PropTypes.func,
  protocol: PropTypes.func,
  url: PropTypes.string,
  materials: PropTypes.object,
  resources: PropTypes.object,
  gpu: PropTypes.bool,
  resolution: PropTypes.number,
  up: PropTypes.array,
  stats: PropTypes.bool,
  updateView: PropTypes.object,
  renderOrder: PropTypes.object,
  lineShader: PropTypes.func,
  lineShaderOptions: PropTypes.object,
  meshShader: PropTypes.func,
  meshShaderOptions: PropTypes.object,
  envMap: PropTypes.object,
  csysTextures: PropTypes.array,
  interpolatePoints: PropTypes.bool
}, _class2.defaultProps = {
  debug: Defaults.debug,
  pool: pool,
  protocol: protocol,
  url: 'http://localhost:8181',
  materials: Defaults.materials,
  resolution: Defaults.resolution,
  up: Defaults.up,
  stats: Defaults.stats,
  updateView: Defaults.updateView,
  renderOrder: Defaults.renderOrder,
  meshShader: Defaults.meshShader,
  meshShaderOptions: Defaults.meshShaderOptions,
  interpolatePoints: false
}, _temp)) || _class);
export { SessionProvider as default };