import _construct from "@babel/runtime/helpers/construct";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";

var _dec, _dec2, _class, _class2, _temp;

import * as THREE from 'three';
import React from 'react';
import PropTypes from 'prop-types';
import Defaults from 'awv3/core/defaults';
import ViewImpl from 'awv3/core/view';
import { subscribe, moduleContext } from 'react-contextual';
import SessionProvider from './SessionProvider';
import Canvas from './Canvas';
var View = (_dec = moduleContext(), _dec2 = subscribe([SessionProvider, Canvas], function (session, canvas) {
  return {
    session: session,
    canvas: canvas
  };
}), _dec(_class = _dec2(_class = (_temp = _class2 =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(View, _React$PureComponent);

  function View(props) {
    var _this;

    _this = _React$PureComponent.call(this) || this;
    _this.interface = new ViewImpl(props.canvas, {
      up: _construct(THREE.Vector3, props.up),
      ambientIntensity: props.ambientIntensity,
      stats: props.stats
    });
    return _this;
  }

  var _proto = View.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.props.pool !== undefined && this.interface.scene.add(this.props.pool);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    if (this.interface) {
      this.interface.destroy();
      delete this.interface;
    }
  };

  _proto.render = function render() {
    var Context = this.props.context;
    return React.createElement(Context.Provider, {
      value: this.interface,
      children: this.props.children || null
    });
  };

  return View;
}(React.PureComponent), _class2.propTypes = {
  up: PropTypes.array,
  stats: PropTypes.bool,
  ambientIntensity: PropTypes.number
}, _class2.defaultProps = {
  up: Defaults.up,
  stats: Defaults.stats,
  ambientIntensity: Defaults.ambientIntensity
}, _temp)) || _class) || _class);
export { View as default };